/* Enumeration of Maximal-frequent and Minimal-infrequent Set (EMMS.c) */
/* 2003/9/1 Takeaki Uno */
/* This program is available for only academic use.
   Neither commercial use, modification, nor re-distribution is allowed */


#ifndef _EMMS_c_
#define _EMMS_c_

#define SHDUAL_subroutine
#define SHDUAL_OUTPUT
#define SHDUAL_BA

/* FREQSET_PROBLEM:specify the problem, 
    1:Frequent set, 2:Closed set 3:Maximal Frequent Set  */
/* #define FREQSET_PROBLEM 3 */

/* FREQSET_OUTPUT: specify output way
    1:usual, 2:fast version, 3:no output */
/* #define FREQSET_OUTPUT 3 */

#include"freqset_.c"
#include"shdual.c"

int prv_iterations, max_iterations =0;
int maxcount = 0, mincount = 0;


/* if K is frequent, c := complement ( max freq. including K ) */
int EMAXMIN_check ( QUEUE *K, QUEUE *S ){
  int i;
  QUEUE_F_LOOP_ ( *K, i ) K->q[i] += G.node1_num;
  FREQSET_compute_XK ( K, S );  /* compute X(K) */
  if ( QUEUE_LENGTH(*S) < v1bound ){ /* if K is infrequent, then return */
    /*    if ( pflag & 32 ){
      fprintf (fp, "min: ");
      FIM_perm_output ( K, 0 );
      QUEUE_cpy_ ( &cliq, K );
      qsort_int ( cliq.q, cliq.t );
      QUEUE_F_LOOP_ ( cliq, i ) printf ("%d ", cliq.q[i] );
      printf ("    min\n");
    } */
    QUEUE_F_LOOP_ ( *K, i ) K->q[i] -= G.node1_num;
    mincount++;
    return ( 0 );
  }
  maxcount++;
  FREQSET_mk_maxfreq(&cliq, S); /* cliq := maximal frequent set including K */
  qsort_int ( cliq.q, cliq.t );
  FIM_perm_output ( &cliq, QUEUE_LENGTH(*S) ); /* output cliq */
  QUEUE_F_LOOP_ ( *K, i ) K->q[i] -= G.node1_num;
  QUEUE_F_LOOP_ ( cliq, i ) cliq.q[i] -= G.node1_num;
/*  if ( pflag & 16 ){
    if ( iterations - prv_iterations > max_iterations )
      max_iterations = iterations - prv_iterations;
    prv_iterations = iterations;
  } */
  return ( 1 );
}

/* if K is infrequent, then return 
   if K is frequent, then find a maximal frequent set K' including K, 
   output K', and add K' to the instance of dualization */
int SHDUAL_output ( SGRAPH *G, BARRAY *SBA, QUEUE *K, QUEUE *uncov ){
  int j, v;

  /*  count++;
  if ( count >= 1000000000 ) {
    printf ("total num = %d\n", count);
    exit (1);
  }*/
  
  if ( EMAXMIN_check ( K, &stmp ) ){ /* check the frequency */
    if ( G->node_num == G->node_end ){
      printf ("SHDUAL_output_: out of memory");
      exit(1);
    }
    QUEUE_init ( &(G->edge[G->node_num]), QUEUE_LENGTH(cliq)+1); /* add cliq to the instance of dualization */
    QUEUE_cpy_ ( &(G->edge[G->node_num]), &cliq );
    G->edge[G->node_num].q[G->edge[G->node_num].t] = G->node1_num;
    QUEUE_ins_ ( uncov, G->node_num );
    BARRAY_init ( &SBA[G->node_num], G->node1_num ); /* make a row of adjacency matrix corresponding to cliq */
    BARRAY_reset_interval ( &SBA[G->node_num], 0, G->node1_num-1 );
    QUEUE_FE_LOOP_ ( cliq, j, v ) BARRAY_SET ( SBA[G->node_num], v );
    G->node_num++;
    return (1);
  }
  return (0);
}



#define IBE_MAX 1000000
main ( int argc , char *argv[] ){
  int i;
  SGRAPH SG;


  pflag = 0; /* initializations */
  if ( argc <3 ) goto ERROR;
  v1bound = atoi(argv[2]);
  G.edge = QUEUE_load2 ( argv[1], &(G.node_end), &(G.node1_num), 3 );
  G.node_end += G.node1_num;
  FREQSET_init ( 7 );
  if ( argc == 3 ) fp == NULL;
  else fopen2w ( fp, argv[3], "SATO_outputfile");
  QUEUE_init ( &stmp, G.node1_num+2 );

  SG.node1_num = G.node_end-G.node1_num;
  SG.node_end = IBE_MAX + SG.node1_num;
  SG.node_num = SG.node1_num;
  malloc2 ( SG.edge, QUEUE, SG.node_end, "main", "SG.edge");
  el = intarray_malloc_const  ( G.node_end, -1 );

    /* call mainroutine ( dualization ) */
  SHDUAL_main ( &SG );

    /* ending */
  FIM_output2 ();
  if ( fp ) fclose ( fp );
/*  FREQSET_end ( 7 );
  free ( el );
  intarray2_free_buf (); */
#if FREQSET_OUTPUT==3
  printf ("max %d min %d iter %d\n", maxcount, mincount, iterations);
  printf ("%d %d\n", c1, c2);
#endif
  exit (0);

  ERROR:;
  printf ("usege: IBE input-filename threshold [output-filename]\n");
  exit (1);

}

#endif
